"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Modified = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = require("react");
var _reactCodemirror = require("@uiw/react-codemirror");
var _view = require("@codemirror/view");
var _store = require("./store");
var _excluded = ["extensions", "value", "selection", "onChange"];
var Modified = function Modified(props) {
  var _props$extensions = props.extensions,
    extensions = _props$extensions === void 0 ? [] : _props$extensions,
    value = props.value,
    selection = props.selection,
    onChange = props.onChange,
    otherOption = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var _useStore = (0, _store.useStore)(),
    theme = _useStore.theme,
    dispatch = _useStore.dispatch;
  var defaultExtensions = (0, _reactCodemirror.getDefaultExtensions)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, otherOption), {}, {
    theme: theme
  }));
  var updateListener = _view.EditorView.updateListener.of(function (vu) {
    if (vu.docChanged && typeof onChange === 'function') {
      var doc = vu.state.doc;
      var val = doc.toString();
      onChange(val, vu);
    }
  });
  (0, _react.useEffect)(function () {
    return dispatch({
      modified: {
        doc: value,
        selection: selection,
        extensions: [updateListener].concat((0, _toConsumableArray2["default"])(defaultExtensions), (0, _toConsumableArray2["default"])(extensions))
      },
      modifiedExtension: {
        onChange: onChange,
        option: otherOption,
        extension: [updateListener, extensions]
      }
    });
  }, [props]);
  return null;
};
exports.Modified = Modified;
Modified.displayName = 'CodeMirrorMerge.Modified';